Subject: Re: [Bitcoin-development] Decentralized digital asset exchange with honest pricing and market depth

From: Peter Todd <[email-masked]>
Date: Mon, 10 Feb 2014 14:32:47 -0500

On Sun, Feb 09, 2014 at 03:44:34PM -0500, Peter Todd wrote:
> On Sun, Feb 09, 2014 at 01:04:58PM -0500, Peter Todd wrote:
> > Alex Mizrahi recently outlined a mechanism(1) based on SIGHASH_SINGLE
> > that allows colored coins and similar embedded consensus system assets
> > to be securely transferred to another party in exchange for Bitcoins
> > atomically. In summary his p2p 2-step-trade mechanism operates as
> > follows:
> 
> I'm told there's probably at least one if not more earlier
> attributions/reinventions for the 2-step-trade protocol using
> SIGHASH_SINGLE. Please reply with them if you have them so we can give
> credit where credit is due.

Got this:

Message-ID: <[email-masked]>
Date: Tue, 24 Sep 2013 06:08:10 -0700
From: Mark Friedenbach <[email-masked]>
Organization: Monetize.io Inc.
To: Meni Rosenfeld <[email-masked]>
Subject: Re: Freimarkets and investment

If assets were tagged you could do a very limited form of pre-signed offers:

in: 10 btc SINGLE|ANYONECANPAY
out: 1 AAA

These are composable, in that you can append the inputs and outputs of
multiple offers together and result in a valid transaction. However this
is pretty much the limit of what is possible without adding new SIGHASH
modes, and if you're going to hard-fork to add tagging, then you might
as well go the whole distance with explicit hierarchical
sub-transactions as we did with Freimarkets.

Cheers,
Mark

On 9/24/13 5:44 AM, Meni Rosenfeld wrote:
> Hi Jorge,
> 
> The video was sent to me by Amos Meiri, I think eToro funded its production.
> 
> Maybe I don't understand SIGHASH_ANYONECANPAY very well. In the
> transaction, there will be an output of 1 "my stock" to an initially
> unknown address. Can I provide a signature for my input of 1 "my stock"
> that will be valid even with the output details provided later?
> 
> In any case, I think that's out of scope for the presentation.
> 
> Meni
> 
> On 24/09/2013 13:10, Jorge Timón wrote:
>> Yes, it's a nice presentation.
>> I love the video with the chameleons that you link at the end !!
>>
>> As a little sugestion, I think the biggest advantage of tagging is not
>> inflatable assets, it's open binding orders. Even without granular
>> subtransactions as freimarket has, you could sign your input (say,
>> representing 1 "My stock") and only the output you're interested in
>> (say 100 bitstampUSD to myAddress) with SIGHASH_SINGLE |
>> SIGHASH_ANYONECANPAY.
>>
>> Without tagging, you need to know where the inputs come from to check
>> they're really bitstampUSD, because the network won't enforce the "100
>> bistampUSD" in your output, any uncolored coins filling the btc
>> quantity you wanted to represent those 100 usd will be ok, for miners.
>>
>> Goog luck with the talk, I'm eager to hear it.
>>
>> By the way, Mark, the explanation of the blockchain image sounds a
>> little bit like hashcasttle, no? well, just merged mining every new
>> asset, sounds like jaromil's freecoin too.
>>
>>
>> On 9/24/13, Meni Rosenfeld <[email-masked]> wrote:
>>> Hi Mark,
>>>
>>> We currently have a more general mathematical framework for the concept of
>>> colored coins - a color is a combination of initial state and a kernel
>>> function that maps input colors to output colors. Order-based coloring is
>>> one such kernel function, tagging is another. As long as you can point at an
>>> output and say what its color is, we call it a colored coin system.
>>>
>>> The blockchain image is a stand-in for "using a new block chain for each
>>> asset".
>>>
>>> Meni
>>>
>>> On 24/09/2013 00:42, Mark Friedenbach wrote:
> Hi Meni,
> 
> I did call Freimarkets "colored coins" in the early days, but the term
> colored coin itself within the community seems to have become
> identified with the specific proposal of assigning value to specific
> satoshis, and running an order based coloring algorithm to determine
> asset flow, e.g. Bitcoin-X. Freimarkets allows issuance of entirely
> new assets and has explicit tagging of outputs, so we decided to avoid
> the phrase "colored coin" so as to keep from confusing people. But as
> an academic, yes you are correct.
> 
> You presentation looks great. BTW, what's the first logo for the
> "Alternative token systems" slide? Or is that just a stand-in for the
> block chain?
> 
> Mark
> 
> On 9/23/13 12:24 PM, Meni Rosenfeld wrote:
>>>>>> Hi,
>>>>>>
>>>>>> As you might know I'm giving a talk about Colored Coins in
>>>>>> Amsterdam.
>>>>>>
>>>>>> My presentation is available at
>>>>>> https://bitcoil.co.il/files/Colored Coins.pptx (I'm not posting
>>>>>> this link publicly until after the talk).
>>>>>>
>>>>>> I'll be happy for any feedback.
>>>>>>
>>>>>> I'm listing Freimarkets as an implementation of Colored Coins. It
>>>>>> doesn't look like you're identifying with the term, but it does fit
>>>>>> the definition (and though it does obviously do much more than
>>>>>> just implement colored coins.)
>>>>>>
>>>>>> Thanks, Meni
>>>>
>>>
>>
> 

-- 
'peter'[:-1]@petertodd.org
0000000076654614e7bf72ac80d47c57bca12503989f4d602538d3cd7892ca7d